#ifndef RECTANGLE_BOUNDTRACKER_H_
#define RECTANGLE_BOUNDTRACKER_H_
#include <opencv2/opencv.hpp>
#include <opencv2/tracking.hpp>
#include "../UI.h"
#include <memory>

class BoundTracker {
	std::shared_ptr<int> lastKey;
	std::shared_ptr<UI> ui;
	cv::Rect2d roi;
	unsigned queueSize = 20;
	std::deque<cv::Rect2d> deadConsistency;

	cv::Ptr<cv::Tracker> tracker = cv::TrackerKCF::create();

public:
	BoundTracker(std::shared_ptr<int> lastKey, std::shared_ptr<UI> ui);
	void init(cv::Rect2d roi);
	bool track();
	void setROI(cv::Rect2d roi);
	cv::Rect2d getROI() const;
	virtual ~BoundTracker();
};

#endif /* RECTANGLE_BOUNDTRACKER_H_ */
