#ifndef RECTANGLE_CONFIDENCE_H_
#define RECTANGLE_CONFIDENCE_H_
#include <opencv2/opencv.hpp>
#include <queue>
#include <vector>
#include "../UI.h"
#include <memory>

class Confidence {
	float similarity;
	unsigned queueLength = 0;
	std::shared_ptr<int> lastKey;
	std::shared_ptr<UI> ui;
	bool drawBounds = false;
	cv::Scalar boundColor {30, 30, 255};

public:
	std::deque<std::vector<cv::Rect>> confidenceQueue;
	std::vector<cv::Rect> confident;

	Confidence(std::shared_ptr<int> lastKey, std::shared_ptr<UI> ui, unsigned history = 5, float similarity = 0.75);
	bool check(std::vector<cv::Rect> contours);
	std::vector<cv::Rect> rectangleBounds() const;
	void drawBoundsOnMat(cv::Mat &mat);
	virtual ~Confidence();
};

#endif /* RECTANGLE_CONFIDENCE_H_ */
