#ifndef RECTANGLE_RULER_H_
#define RECTANGLE_RULER_H_
#include "../UI.h"
#include "../UIListener.hpp"
#include <memory>

class Ruler: public UIListener {
	cv::Point distanceTextPos {5, 60};
	cv::Point confTextPos {5, 75};
	cv::Scalar textFontColor {20, 20, 20};

	bool decimal = false;
	int detectedWidth = 0;
	std::shared_ptr<UI> ui;
	std::shared_ptr<int> lastKey;
	float distance = 0;
	float givenWidth = 0;
	float focalLength = 0;
	float HFOV = 60;
	bool inputtingVal = false;
	std::deque<char> numBuild;

public:
	Ruler(std::shared_ptr<UI> ui, std::shared_ptr<int> lastKey);
	float estimateFocalLength();
	int estimateDistance();
	void update();
	void setDetectedWidth(int width);
	void componentSetup();
	void updateUI();
	void toggleInput();
	virtual ~Ruler();

private:
	void inputUpdate();
};

#endif /* RECTANGLE_RULER_H_ */
